/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_ARGS_H_
#define __GDAM_ARGS_H_

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
/*
#include "default-file.h"
*/

extern int gdam_num_options;
extern const char* gdam_options[];
extern const char* gdam_option_descriptions[];

/* The fmt string below may have two %s's in it:
 * the first is the option name, the second is the
 * option description. */
void gdam_print_usage(FILE* fp, const char* fmt);

gboolean gdam_parse_args(int* argc, char*** argv);

extern int gdam_use_threads;
extern char* gdam_dev_name;
extern char* gdam_dev1_name;
extern char* gdam_songdb_name;
extern /*GdkModifierType*/ int gdam_drag_mask;
extern int gdam_bufsize;
extern int gdam_fragnum;
extern int gdam_logfragsize;

#endif
