/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SYNTH_SOURCE_H_
#define __GDAM_SYNTH_SOURCE_H_

#include <gdam/gdamsource.h>

typedef struct _GdamSynthSource GdamSynthSource;
typedef struct _GdamSynthSourceClass GdamSynthSourceClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_synth_source_get_type();
#define GDAM_TYPE_SYNTH_SOURCE			(gdam_synth_source_get_type ())
#define GDAM_SYNTH_SOURCE(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SYNTH_SOURCE, GdamSynthSource))
#define GDAM_SYNTH_SOURCE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SYNTH_SOURCE, GdamSynthSourceClass))
#define GDAM_IS_SYNTH_SOURCE(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SYNTH_SOURCE))
#define GDAM_IS_SYNTH_SOURCE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SYNTH_SOURCE))

struct _GdamSynthSourceClass {
	GdamSourceClass		   synth_source_class;
	int                      (*synthesize)(GdamSynthSource* synth_source,
	                                       gdouble*         buffer,
					       int              buffer_len);
};

struct _GdamSynthSource {
	GdamSource		  synth_source;
};

int gdam_synth_source_synthesize(GdamSynthSource*    source, 
            			 gdouble*            output_buffer,
				 int                 amount_to_read);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
